SystemOrganization addCategory: #'MC2-Squeak-Tests'!
SystemOrganization addCategory: #'MC2-Squeak-Adaptors'!
SystemOrganization addCategory: #'MC2-Squeak-Fakes'!
SystemOrganization addCategory: #'MC2-Squeak-Slices'!

!MDTimestamp class methodsFor: '*mc2-squeak' stamp: 'cwp 6/18/2005 16:04'!
fromSqueakMethodStamp: aString
	| stream month day year hour minute |
	stream := ReadStream on: aString.
	[stream peek isDigit] whileFalse: [stream next].
	month := (stream upTo: $/) asNumber.
	day := (stream upTo: $/) asNumber.
	year := (stream upTo: Character space) asNumber.
	hour := (stream upTo: $:) asNumber.
	minute := (stream upTo: Character space) asNumber.
	stream atEnd ifFalse: [(stream next: 2) = 'pm' ifTrue: [hour := hour + 12]].
	^ self year: year month: month day: day hour: hour minute: minute second: 0! !

Object subclass: #MDFakeClassDescription
	instanceVariableNames: 'superclass methodDict format instanceVariables organization name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Fakes'!

MDFakeClassDescription subclass: #MDFakeClass
	instanceVariableNames: 'subclasses classPool sharedPools environement category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Fakes'!

!MDFakeClass class methodsFor: 'instance creation' stamp: 'cwp 8/27/2005 11:50'!
basedOn: aClass
	^ self new initializeFromClass: aClass theNonMetaClass! !

!MDFakeClass methodsFor: 'mutation' stamp: 'cwp 8/27/2005 10:37'!
addClassVarName: aString
	classPool at: aString asSymbol put: nil! !

!MDFakeClass methodsFor: 'mutation' stamp: 'cwp 8/28/2005 16:11'!
addSharedPool: aSharedPool 
	(self sharedPools includes: aSharedPool)
		ifTrue: [^self error: 'This is already in my shared pool list'].
	sharedPools == nil
		ifTrue: [sharedPools _ OrderedCollection with: aSharedPool]
		ifFalse: [sharedPools add: aSharedPool]! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
category
	^category! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
category: anObject
	category := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
classPool
	^classPool! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
classPool: anObject
	classPool := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 10:48'!
classVarNames
	^ classPool keys! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
environement
	^environement! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
environement: anObject
	environement := anObject! !

!MDFakeClass methodsFor: 'initialize-release' stamp: 'cwp 8/28/2005 16:43'!
initializeFromClass: aClass
	superclass _ aClass superclass.
	methodDict _ aClass methodDict copy.
	format _ aClass format.
	name _ aClass name.
	organization _ aClass organization copy.
	instanceVariables _ aClass instVarNames.
	classPool _ aClass classPool copy.
	sharedPools _ aClass sharedPools copy.
	! !

!MDFakeClass methodsFor: 'testing' stamp: 'cwp 8/27/2005 12:50'!
isMeta
	^ false! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
sharedPools
	^sharedPools! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
sharedPools: anObject
	sharedPools := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
subclasses
	^subclasses! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
subclasses: anObject
	subclasses := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:55'!
theMetaClass
	^MDFakeMetaclass basedOn: self theRealClass class! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:52'!
theNonMetaClass
	^ self! !

!MDFakeClassDescription methodsFor: 'mutation' stamp: 'cwp 8/27/2005 11:36'!
addInstVarName: aString
	instanceVariables _ instanceVariables copyWith: aString! !

!MDFakeClassDescription methodsFor: 'copying' stamp: 'cwp 8/27/2005 11:36'!
copy
	^ self class basedOn: self! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
format
	^format! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
format: anObject
	format := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
instVarNames
	^ instanceVariables! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
instVarNames: anArray
	instanceVariables _ anArray! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
methodDict
	^methodDict! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
methodDict: anObject
	methodDict := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:38'!
name
	^ name! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:38'!
name: aSymbol
	name _ aSymbol! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
organization
	^organization! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
organization: anObject
	organization := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
superclass
	^superclass! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
superclass: anObject
	superclass := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:55'!
theRealClass
	^Smalltalk classNamed: name! !

MDFakeClassDescription subclass: #MDFakeMetaclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Fakes'!

!MDFakeMetaclass class methodsFor: 'as yet unclassified' stamp: 'cwp 8/27/2005 11:56'!
basedOn: aMetaclass
	^ self new initializeFromMetaclass: aMetaclass theMetaClass! !

!MDFakeMetaclass methodsFor: 'initialize-release' stamp: 'cwp 8/27/2005 11:53'!
initializeFromMetaclass: aMetaclass
	superclass _ aMetaclass superclass.
	methodDict _ aMetaclass methodDict copy.
	format _ aMetaclass format.
	name _ aMetaclass theNonMetaClass name.
	organization _ aMetaclass organization copy.
	instanceVariables _ aMetaclass instVarNames.
! !

!MDFakeMetaclass methodsFor: 'testing' stamp: 'cwp 8/27/2005 12:50'!
isMeta
	^ true! !

!MDFakeMetaclass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:53'!
name
	^ name, ' class'! !

!MDFakeMetaclass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:52'!
theMetaClass
	^ self! !

!MDFakeMetaclass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:55'!
theNonMetaClass
	^ MDFakeClass basedOn: self theRealClass! !

Object subclass: #MDSqueakElementAdaptor
	instanceVariableNames: 'element system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

MDSqueakElementAdaptor subclass: #MDSqueakClassAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:39'!
category
	^ self elementClass category! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:30'!
classVariablesString
	^ self send: #classVariablesString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 12/2/2005 22:47'!
elementClass
	^ system at: element theClassName ifAbsent: [nil]! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:39'!
format
	^ self elementClass typeOfClass! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:30'!
instanceVariablesString
	^ self send: #instanceVariablesString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/15/2005 15:31'!
isLoadable: properties 
	self superclassFrom: properties ifAbsent: [^ false].
	^ true! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 12/1/2005 22:31'!
isPresent
	^ (system at: element theClassName ifAbsent: [^ false])
		isBehavior! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 22:25'!
load: properties
	| superClass |
	superClass _ Smalltalk at: properties superclassName.
	ClassBuilder new
		name: element theClassName 
		inEnvironment: superClass environment 
		subclassOf: superClass
		type: properties format 
		instanceVariableNames: self instanceVariablesString 
		classVariableNames: self classVariablesString 
		poolDictionaries: self sharedPoolsString
		category: properties category
! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/5/2005 23:02'!
propertyNames
	^ #(category format superclassName)! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 12:39'!
remove
	self elementClass ifNotNilDo: [:class | class removeFromSystem]! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:39'!
send: aSelector toClassIfNil: aBlock
	| class |
	class := self elementClass.
	^ class 
		ifNotNil: [class perform: aSelector]
		ifNil: aBlock! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:31'!
sharedPoolsString
	^ self send: #sharedPoolsString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 12/1/2005 23:12'!
superclassFrom: properties ifAbsent: absentBlock 
	| global |
	global _ system 
				at: properties superclassName 
				ifAbsent: [^ absentBlock value].
	^ (global isBehavior)
		ifTrue: [global]
		ifFalse: absentBlock! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:40'!
superclassName
	^ self elementClass superclass name! !

MDSqueakElementAdaptor subclass: #MDSqueakClassCommentAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:22'!
isPresent
	^ self elementClass hasComment! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:55'!
load: properties
	self elementClass
		classComment: properties text
		stamp: (self stampFromProperties: properties)! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 11/17/2007 01:22'!
propertyNames
	^ #(text initials timeStamp)! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:59'!
remove
	self elementClass organization classComment: nil stamp: nil.
! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:34'!
stamp
	^ self elementClass organization commentStamp! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 3/11/2005 21:02'!
text
	^ self elementClass comment asString! !

MDSqueakElementAdaptor subclass: #MDSqueakClassVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:49'!
isPresent
	^ self elementClass classVarNames includes: element name! !

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 14:00'!
load: properties
	self isPresent ifFalse: [self elementClass addClassVarName: element name]! !

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:59'!
remove
	self isPresent ifTrue: [self elementClass removeClassVarName: element name]! !

!MDSqueakElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 12/11/2005 10:57'!
forElement: anElement
	^ self forElement: anElement inSystem: Smalltalk! !

!MDSqueakElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 12/1/2005 21:58'!
forElement: anElement inSystem: aSystemEditor
	^ self new setElement: anElement system: aSystemEditor! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 3/2/2006 18:08'!
display: properties
	^ properties asString! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:44'!
elementClass
	^ self elementClassIfAbsent: [nil]! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 12/11/2005 11:01'!
elementClassIfAbsent: aBlock
	^ system at: element theClassName ifAbsent: aBlock! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 11/17/2007 01:25'!
initials
	| initials |
	initials _ self stamp copyUpTo: $ .
	^ initials isEmpty ifFalse: [initials] ifTrue: [nil]! !

!MDSqueakElementAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 21:40'!
is: name upToDateIn: properties
	^ (properties at: name ifAbsent: [^ true]) = (self perform: name)
	! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/15/2005 15:47'!
isLoadable: properties
	self elementClassIfAbsent: [^ false].
	^ true! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 21:40'!
isUpToDate: properties 
	self propertyNames
		do: [:property | (self is: property upToDateIn: properties) ifFalse: [^ false]].
	^ true
! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:08'!
load: properties
	self subclassResponsibility! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'avi 3/16/2005 12:21'!
merge: aPropertyDictionary into: otherPropertyDictionary onFailure: aBlock
	^ aBlock value! !

!MDSqueakElementAdaptor methodsFor: 'properties' stamp: 'cwp 2/6/2005 23:39'!
propertyNames
	^ #()! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:08'!
remove
	self subclassResponsibility! !

!MDSqueakElementAdaptor methodsFor: 'initialize-release' stamp: 'cwp 12/1/2005 21:57'!
setElement: anElement system: aSystemEditor
	element _ anElement.
	system _ aSystemEditor! !

!MDSqueakElementAdaptor methodsFor: 'private' stamp: 'cwp 11/17/2007 01:24'!
stampFromProperties: properties
	| initials timestamp |
	initials _ properties at: #initials ifAbsent: ['<nobody>'].
	timestamp _ properties at: #timeStamp ifAbsent: [^ '<no timestamp>'].
	^ timestamp printFormat: initials, ' %l/%e/%Y %H:%M'
	! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 4/24/2006 14:12'!
timeStamp
	| stamp |
	stamp := self stamp.
	^ (#('' '<historical>' '<no timestamp>') includes: stamp)
		ifFalse: [MDTimestamp fromSqueakMethodStamp: stamp]
		ifTrue: [nil]
! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/1/2006 21:02'!
update: properties
	self propertyNames do: 
		[:name | (self perform: name) ifNotNilDo: 
			[:value | properties at: name put: value]]! !

MDSqueakElementAdaptor subclass: #MDSqueakInstVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

MDSqueakInstVarAdaptor subclass: #MDSqueakClassInstVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakClassInstVarAdaptor methodsFor: 'accessing' stamp: 'cwp 3/4/2005 15:04'!
elementClassIfAbsent: aBlock
	^ (super elementClassIfAbsent: aBlock) class! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 8/20/2005 18:21'!
isPresent
	^ (self elementClassIfAbsent: [^ false])
		instVarNames includes: element name! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:56'!
load: properties
	self isPresent ifFalse: [self elementClass addInstVarName: element name]! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:56'!
remove
	self isPresent ifTrue: [self elementClass removeInstVarName: element name]! !

MDSqueakElementAdaptor subclass: #MDSqueakMethodAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 23:06'!
category
	^ self elementClass organization categoryOfElement: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:44'!
compiledMethod 
	^ self elementClass compiledMethodAt: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'avi 3/22/2006 19:49'!
display: properties
	^ properties source! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 15:24'!
elementClassIfAbsent: aBlock
	| nonMetaClass |
	nonMetaClass := super elementClassIfAbsent: aBlock.
	^ element classIsMeta
		ifTrue: [nonMetaClass class]
		ifFalse: [nonMetaClass]! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/3/2005 23:22'!
isPresent
	^ self elementClass includesSelector: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'avi 3/14/2005 18:36'!
isUpToDate: aPropertyDictionary
	aPropertyDictionary localReference ifNotNilDo:
		[:compiledMethod |
		compiledMethod = self compiledMethod ifTrue: [^ true]].
	^ super isUpToDate: aPropertyDictionary! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 1/14/2006 18:05'!
load: properties
	| selector |
	selector _ self elementClass
					compile: (properties at: #source ifAbsent: [self source])
					classified: (properties at: #category ifAbsent: [self category])
					withStamp: (self stampFromProperties: properties)
					notifying: nil
					logSource: true.
! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 11/17/2007 01:24'!
propertyNames
	^ #(initials timeStamp category source)! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 8/14/2005 19:57'!
remove
	(self elementClassIfAbsent: [^ self])
		removeSelector: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 3/11/2005 20:44'!
source
	^ (self elementClass sourceCodeAt: (element selector)) asString.! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:30'!
stamp
	^self compiledMethod timeStamp! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'avi 3/14/2005 18:32'!
update: aPropertyDictionary
	super update: aPropertyDictionary.
	aPropertyDictionary localReference: self compiledMethod! !

MDSqueakElementAdaptor subclass: #MDSqueakPoolImportAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakPoolImportAdaptor methodsFor: 'private' stamp: 'cwp 12/22/2006 22:50'!
importedPool
	^ system at: element poolName.
	! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:34'!
isPresent
	^ self elementClass sharedPools anySatisfy: [:ea | ea name = element poolName]! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 12/23/2006 19:21'!
load: properties
	| class pool |
	class _ self elementClass.
	pool _ self importedPool.
	(class sharedPools includes: pool)
		ifFalse: [class addSharedPool: pool]! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:44'!
remove
	"Work around a bug in Class>>removeSharedPool:"
	
	self elementClass sharedPools remove: self importedPool ifAbsent: []! !

MDSqueakElementAdaptor subclass: #MDSqueakSliceAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakSliceAdaptor methodsFor: 'public' stamp: 'cwp 1/18/2007 22:01'!
isLoadable: properties
	^ true! !

!MDSqueakSliceAdaptor methodsFor: 'public' stamp: 'cwp 1/18/2007 22:57'!
isPresent
	^ system includesId: element id! !

!MDSqueakSliceAdaptor methodsFor: 'public' stamp: 'cwp 12/29/2007 22:35'!
isUpToDate: properties
	^ self properties = properties
	! !

!MDSqueakSliceAdaptor methodsFor: 'public' stamp: 'cwp 11/9/2007 22:22'!
load: properties
	(system objectWithId: element id satisfies: [:slice | slice definition = properties])
		ifFalse: [system register: (MDSlice forDefinition: properties)]! !

!MDSqueakSliceAdaptor methodsFor: 'private' stamp: 'cwp 12/29/2007 22:35'!
properties
	^ (system objectWithId: element id) properties.! !

!MDSqueakSliceAdaptor methodsFor: 'public' stamp: 'cwp 11/9/2007 22:25'!
remove
	system unregisterId: element id! !

!MDSqueakSliceAdaptor methodsFor: 'public' stamp: 'cwp 12/29/2007 22:36'!
update: properties
	| props |
	props _ self properties.
	properties keys do: 
		[:ea | 
		(props includesKey: ea) 
			ifFalse: [properties removeKey: ea]].
	props keysAndValuesDo:
		[:k :v | properties at: k put: v]! !

!Object methodsFor: '*mc2-squeak-ui' stamp: 'cwp 4/25/2005 04:04'!
displayOn: aStream
	self printOn: aStream! !

!Object methodsFor: '*mc2-squeak-ui' stamp: 'cwp 4/25/2005 04:03'!
displayString
	^ String streamContents: [:stream | self displayOn: stream]! !

!MDTimestampTest methodsFor: '*mc2-squeak' stamp: 'cwp 4/7/2005 23:35'!
testFromSqueakMethodStamp
	| ts |
	ts _ MDTimestamp fromSqueakMethodStamp: 'cwp 4/7/2005 01:30'.
	self assert: ts printString = '7 April 2005 1:30:00 am'! !

MDImageProxy subclass: #MDSqueakImageProxy
	instanceVariableNames: 'editor slices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakImageProxy class methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 23:40'!
createProject
	
	^ MDProject forImageProxy: self new! !

!MDSqueakImageProxy class methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2007 21:14'!
createProjectNamed: aString
	
	^ (MDProject forImageProxy: self new)
		name: aString;
		yourself! !

!MDSqueakImageProxy class methodsFor: 'as yet unclassified' stamp: 'cwp 11/6/2007 22:20'!
installDefault
	MDWorkingCopy defaultImageProxy: self new! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:46'!
adaptorForClassCommentElement: anElement
	^ MDSqueakClassCommentAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:43'!
adaptorForClassElement: anElement
	^ MDSqueakClassAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:49'!
adaptorForClassInstVarElement: anElement
	^ MDSqueakClassInstVarAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:48'!
adaptorForClassVarElement: anElement
	^ MDSqueakClassVarAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:50'!
adaptorForInstVarElement: anElement
	^ MDSqueakInstVarAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:53'!
adaptorForMethodElement: anElement
	^ MDSqueakMethodAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:54'!
adaptorForPoolImportElement: anElement
	^ MDSqueakPoolImportAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 1/19/2007 20:22'!
adaptorForSliceElement: anElement
	^ MDSqueakSliceAdaptor forElement: anElement inSystem: self slices! !

!MDSqueakImageProxy methodsFor: 'initialize-release' stamp: 'cwp 3/2/2006 21:06'!
initialize
	editor _ Smalltalk! !

!MDSqueakImageProxy methodsFor: 'accessing' stamp: 'cwp 11/10/2007 22:00'!
slices
	^ slices ifNil: [slices _ MDRegistry new]! !

!MDSqueakImageProxy methodsFor: 'accessing' stamp: 'cwp 1/19/2007 20:24'!
slices: aSliceOrganizer
	slices _ aSliceOrganizer! !

!MDSqueakImageProxy methodsFor: 'public' stamp: 'cwp 12/23/2006 21:45'!
transaction: aBlock
	|  result tmp |
	tmp _ editor.
	[editor _ MDPlatform current systemEditor.
	result _ aBlock value.
	editor commit]
		ensure: [editor _ tmp].

	^ result! !

TestCase subclass: #MDAdaptorTest
	instanceVariableNames: 'system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDAdaptorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/6/2005 11:53'!
isAbstract
	^ self name = #MDAdaptorTest! !

!MDAdaptorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2005 21:40'!
shouldInheritSelectors
	^ true! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:43'!
adaptor
	^ self adaptorForElement: self element! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/2/2006 18:05'!
adaptorClass
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 12/1/2005 22:17'!
adaptorForElement: anElement
	^ self adaptorClass forElement: anElement inSystem: self system! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:49'!
bogusClass
	^ MDBogusA! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'cwp 3/23/2005 00:03'!
canBeUnloadable
	^ true! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'cwp 3/2/2006 18:12'!
displayString
	^ self properties asString! !

!MDAdaptorTest methodsFor: 'running' stamp: 'cwp 2/1/2006 21:20'!
editDuring: aBlock
	aBlock value.
	system commit.! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'cwp 11/17/2007 01:25'!
initials
	^ self stamp copyUpTo: $ ! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:48'!
propertyToChange
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'running' stamp: 'cwp 12/22/2006 22:26'!
setUp
	system _ MDPlatform current systemEditor! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 12/3/2005 23:00'!
system
	^ system! !

!MDAdaptorTest methodsFor: 'running' stamp: 'cwp 2/5/2005 20:53'!
tearDown
	self destroyObject! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/23/2005 00:02'!
testClassMissing
	| adaptor |
	self canBeUnloadable 
		ifTrue: [adaptor := self adaptorForElement: self unloadableElement.
				self deny: (adaptor isLoadable: self properties)]! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 18:09'!
testDisplay
	| actual |
	actual _ self adaptor display: self properties.
	self assert: actual = self displayString! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/15/2005 14:45'!
testIsLoadable
	self assert: (self adaptor isLoadable: self properties)
! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:42'!
testIsPresent
	self createObject.
	self assert: self adaptor isPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/23/2005 00:10'!
testIsUpToDate
	self createObject.
	self assert: (self adaptor isUpToDate: self properties)! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/11/2005 22:48'!
testLoad
	self editDuring: [self adaptor load: self properties].
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 21:07'!
testNotPresent
	self deny: self adaptor isPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/12/2005 14:41'!
testNotUpToDate
	| properties |
	self propertyToChange ifNil: [^ self].
	self createObject.
	properties := self properties.
	properties at: self propertyToChange put: self changedValue.
	self deny: (self adaptor isUpToDate: properties)! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/3/2005 23:14'!
testRemove
	self createObject.
	self editDuring: [self adaptor remove].
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/3/2005 23:16'!
testRemoveNotPresent
	self editDuring: [self adaptor remove].
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/11/2005 10:43'!
testUpdate
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self editDuring: [self adaptor update: properties].
	self assert: properties = self properties! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/3/2005 23:17'!
testUpdateSideEffects
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self editDuring: [self adaptor update: properties].
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'cwp 4/9/2005 01:54'!
timeStamp
	^ MDTimestamp fromSqueakMethodStamp: self stamp! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'cwp 2/15/2005 15:56'!
unloadableElement
	self subclassResponsibility! !

MDAdaptorTest subclass: #MDSqueakClassAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakClassAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:42'!
adaptorClass
	^ MDSqueakClassAdaptor ! !

!MDSqueakClassAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 11:55'!
assertObjectHasDefaultProperties
	| class |
	class := Smalltalk 
			at: self bogusClassName 
			ifAbsent: [self signalFailure: 'Class doesn''t exist'].
	self assert: class superclass name = self superclassName.
	self assert: class category = self category.
	self assert: class typeOfClass = self format! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:02'!
bogusClassName
	^ #MDBogusB! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 12:03'!
category
	^ #'Monticello2-Fakes'! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/12/2005 15:05'!
changedValue
	^ #temp! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:16'!
classInstVars
	^ 'aleph beth'! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:07'!
classVariablesString
	^ 'Alpha Beta'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:12'!
classVars
	^ 'Alpha Beta'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:13'!
comment
	^ 'A politician''s comment: it fills the space, while saying nothing.'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:14'!
commentAuthor
	^ self commentStamp copyUpTo: $ ! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:15'!
commentStamp
	^ 'abc 11/29/2004 01:44' ! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 4/9/2005 04:48'!
commentTimeStamp
	^ MDTimestamp fromSqueakMethodStamp: self commentStamp! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:08'!
createObject
	Object 
		subclass: self bogusClassName
		instanceVariableNames: self instanceVariablesString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 11:56'!
destroyObject
	(Smalltalk at: self bogusClassName ifAbsent: [^ self]) removeFromSystem! !

!MDSqueakClassAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 11:58'!
element
	^ MDClassElement className: self bogusClassName! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 21:36'!
format
	^ #normal! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:07'!
instanceVariablesString
	^'one two'! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:06'!
objectIsPresent
	^ Smalltalk hasClassNamed: self bogusClassName asString! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:18'!
properties
	^ MDPropertyDictionary new
		category: self category;
		format: self format;
		superclassName: self superclassName;
		yourself! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/12/2005 14:45'!
propertyToChange
	^ #category! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 23:52'!
sharedPoolsString
	^ 'MDBogusPoolA'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 21:36'!
superclassName
	^ #Object! !

!MDSqueakClassAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/15/2005 16:06'!
testClassMissing
	| properties |
	properties _ self properties.
	properties superclassName: #MDNonExistentClass.
	self deny: (self adaptor isLoadable: properties)! !

!MDSqueakClassAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 12:05'!
testLoadingPreservesVars
	| class |
	self createObject.
	self adaptor load: self properties.
	class := Smalltalk at: self bogusClassName ifAbsent: [self assert: false].
	self assert: class instanceVariablesString = 'one two'.
	self assert: class classVariablesString = 'Alpha Beta'.
	self assert: class sharedPoolsString = self sharedPoolsString.! !

MDAdaptorTest subclass: #MDSqueakClassCommentAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 15:39'!
adaptorClass
	^ MDSqueakClassCommentAdaptor! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/12/2005 14:57'!
assertObjectHasDefaultProperties
	self assert: self bogusClass comment = self text.
	self assert: self bogusClass organization commentStamp = self stamp.! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:51'!
changedValue
	^ 'A different comment for MDBogusA.'! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 14:27'!
createObject
	self bogusClass classComment: self text stamp: self stamp
! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 15:00'!
destroyObject
	self bogusClass organization classComment: nil stamp: nil! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:20'!
element
	^ MDClassCommentElement className: self bogusClass name! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 14:59'!
objectIsPresent
	^ self bogusClass hasComment! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 11/17/2007 01:23'!
properties
	^ MDPropertyDictionary new
		at: #text put: self text;
		at: #initials put: self initials;
		at: #timeStamp put: self timeStamp;
		yourself! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:45'!
propertyToChange
	^ #text! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:18'!
stamp
	^ 'abc 11/29/2004 01:44' ! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/11/2005 20:54'!
testTextAsString
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assert: (properties text isKindOf: String)! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:26'!
text
	^ 'A comment for MDBogusA'! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:06'!
unloadableElement
	^MDClassCommentElement className: #MDNonExistentClass! !

MDAdaptorTest subclass: #MDSqueakClassVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:00'!
adaptorClass
	^ MDSqueakClassVarAdaptor! !

!MDSqueakClassVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 14:04'!
assertObjectHasDefaultProperties
	self assert: self objectIsPresent! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:32'!
classVarName
	^ 'Beta'! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 13:31'!
createObject
	self bogusClass addClassVarName: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:04'!
destroyObject
	self objectIsPresent 
		ifTrue: [self bogusClass removeClassVarName: self classVarName]! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:46'!
element
	^ MDClassVarElement 
		className: self bogusClass name 
		name: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:04'!
objectIsPresent
	^self bogusClass classVarNames includes: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:32'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:46'!
propertyToChange
	"Class variables have no properties and thus can never by out of date."

	^ nil 
	! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:01'!
unloadableElement
	^ MDClassVarElement className: #MDNonExistentClass name: #Foo! !

MDAdaptorTest subclass: #MDSqueakInstVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

MDSqueakInstVarAdaptorTest subclass: #MDSqueakClassInstVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakClassInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/4/2005 15:05'!
adaptor
	^ MDSqueakClassInstVarAdaptor forElement: self element! !

!MDSqueakClassInstVarAdaptorTest methodsFor: 'accessing' stamp: 'cwp 3/4/2005 14:54'!
bogusClass
	^ super bogusClass class! !

!MDSqueakClassInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/4/2005 15:13'!
element
	^ MDClassInstVarElement 
		className: self bogusClass theNonMetaClass name 
		name: self instVarName! !

!MDSqueakClassInstVarAdaptorTest methodsFor: 'constants' stamp: 'cwp 3/4/2005 14:54'!
instVarName
	^ 'beth'! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:02'!
adaptorClass
	^ MDSqueakInstVarAdaptor! !

!MDSqueakInstVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 12:56'!
assertObjectHasDefaultProperties
	self bogusClass instVarNames includes: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:24'!
createObject
	self bogusClass addInstVarName: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 14:07'!
denyObjectIsPresent
	self deny: self objectIsPresent! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:05'!
destroyObject
	self objectIsPresent 
		ifTrue: [self bogusClass removeInstVarName: self instVarName]! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 12:26'!
element
	^ MDInstVarElement 
		className: self bogusClass name 
		name: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:21'!
instVarName
	^'two'! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:05'!
objectIsPresent
	^self bogusClass instVarNames includes: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 13:06'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:48'!
propertyToChange
	"An instance variable has no properties, thus it is always up-to-date"

	^ nil! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:02'!
unloadableElement
	^ MDInstVarElement 
		className: #MDNonExistentClass
		name: self instVarName! !

MDAdaptorTest subclass: #MDSqueakMethodAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

MDSqueakMethodAdaptorTest subclass: #MDSqueakClassMethodAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakClassMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 15:14'!
bogusClass
	^ super bogusClass class! !

!MDSqueakClassMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 15:21'!
element
	^ MDMethodElement 
		className: super bogusClass name
		selector: self theSelector
		classIsMeta: true! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:00'!
adaptorClass
	^ MDSqueakMethodAdaptor! !

!MDSqueakMethodAdaptorTest methodsFor: 'asserting' stamp: 'cwp 8/20/2005 19:10'!
assertObjectHasDefaultProperties
	self assert: (self bogusClass includesSelector: self theSelector).
	self assert: (self bogusClass organization categoryOfElement: self theSelector) = self category.
	self assert: (self bogusClass sourceCodeAt: self theSelector) = self source.
	self assert: (self bogusClass compiledMethodAt: self theSelector) timeStamp = self stamp.! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:24'!
category
	^ #temporary! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 15:06'!
changedValue
	^ #temp! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 11:52'!
createObject
	self bogusClass
		compile: self source
		classified: self category
		withStamp: self stamp
		notifying: nil
		logSource: true! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:15'!
destroyObject
	self bogusClass removeSelector: self theSelector! !

!MDSqueakMethodAdaptorTest methodsFor: 'configuration' stamp: 'cwp 10/23/2006 10:26'!
displayString
	^ self properties source! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 12:16'!
element
	^ MDMethodElement className: self bogusClass name selector: self theSelector! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:07'!
objectIsPresent
	^self bogusClass includesSelector: self theSelector! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 11/17/2007 01:24'!
properties
	^ MDPropertyDictionary new
		initials: self initials;
		category: self category;
		source: self source;
		timeStamp: self timeStamp;
		yourself! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:49'!
propertyToChange
	^ #category! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:23'!
source
	^ 'method1
	^ 1'! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 8/20/2005 19:09'!
stamp
	^ 'abc 11/29/2004 14:44' ! !

!MDSqueakMethodAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/11/2005 20:43'!
testSourceAsString
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assert: (properties source isKindOf: String)! !

!MDSqueakMethodAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 12:14'!
theSelector
	^#method1! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 15:58'!
unloadableElement
	^ MDMethodElement className: #MDNonExistentClass selector: #foo! !

MDAdaptorTest subclass: #MDSqueakPoolImportAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:04'!
adaptorClass
	^ MDSqueakPoolImportAdaptor! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 23:45'!
assertObjectHasDefaultProperties
	self assert: (self bogusClass sharedPools anySatisfy: [:ea | ea name = self poolName])! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 22:56'!
createObject
	self bogusClass addSharedPool: self pool! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 23:09'!
destroyObject
	self bogusClass sharedPools remove: self pool ifAbsent: []! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 23:30'!
element
	^ MDPoolImportElement className: self bogusClass name poolName: self poolName! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 23:46'!
objectIsPresent
	^ self bogusClass sharedPools anySatisfy: [:ea | ea name = self poolName]! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:57'!
pool
	^ Smalltalk at: self poolName! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:59'!
poolName
	^ #MDBogusPoolB! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 23:37'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:49'!
propertyToChange
	"A pool import has no properties and is thus always up-to-date."
	^ nil! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:06'!
unloadableElement
	^ MDPoolImportElement className: #MDNonExistentClass poolName: #Foo! !

MDAdaptorTest subclass: #MDSqueakSliceAdaptorTest
	instanceVariableNames: 'slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 21:54'!
adaptorClass
	^ MDSqueakSliceAdaptor! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/29/2007 22:34'!
assertObjectHasDefaultProperties
	(system objectWithId: slice id) properties = slice properties! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 21:47'!
canBeUnloadable
	^ false! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 23:19'!
changedValue
	^ 'Test2'! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 22:21'!
createObject
	system register: slice! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 21:49'!
destroyObject
	! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 22:49'!
element
	^ MDSliceElement forSlice: slice! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 23:21'!
objectIsPresent
	^ system includesId: slice id! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/29/2007 22:33'!
properties
	^ slice properties! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 23:18'!
propertyToChange
	^ #name! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 22:21'!
setUp
	system _ MDRegistry new.
	slice _ MDExplicitSlice named: 'Test Slice'! !

TestCase subclass: #MDSqueakTransactionTest
	instanceVariableNames: 'proxy commitWasCalled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakTransactionTest methodsFor: 'asserting' stamp: 'cwp 3/2/2006 20:45'!
assertEditorSetFor: aBlock
	| adaptor |
	proxy instVarNamed: 'editor' put: self.
	adaptor _ (aBlock value) adaptedFor: proxy.
	self assert: (adaptor instVarNamed: 'system') == self! !

!MDSqueakTransactionTest methodsFor: 'callbacks' stamp: 'cwp 3/2/2006 18:33'!
commit
	commitWasCalled _ true! !

!MDSqueakTransactionTest methodsFor: 'running' stamp: 'cwp 3/3/2006 15:31'!
endTransactionEarly
	proxy transaction: [^ self].! !

!MDSqueakTransactionTest methodsFor: 'running' stamp: 'cwp 3/2/2006 20:42'!
setUp
	proxy _ MDSqueakImageProxy new.
	commitWasCalled _ false! !

!MDSqueakTransactionTest methodsFor: 'callbacks' stamp: 'cwp 3/2/2006 21:06'!
subject
	^ Smalltalk! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:45'!
testEditorSetForClassAdaptors
	self assertEditorSetFor: [MDClassElement className: self class name].! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:45'!
testEditorSetForClassCommentAdaptors
	self assertEditorSetFor: [MDClassCommentElement className: self class name]! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:48'!
testEditorSetForClassInstVarAdaptors
	self assertEditorSetFor: [MDClassInstVarElement 
							className: self class name 
							name: 'aleph']! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:49'!
testEditorSetForClassVarAdaptors
	self assertEditorSetFor: [MDClassVarElement 
							className: self class name 
							name: 'Alpha']! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:50'!
testEditorSetForInstVarAdaptors
	self assertEditorSetFor: [MDInstVarElement 
							className: self class name 
							name: 'one']! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:52'!
testEditorSetForMethodAdaptors
	self assertEditorSetFor: [MDMethodElement 
							className: self class name 
							selector: #a]! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:54'!
testEditorSetForPoolImportAdaptors
	self assertEditorSetFor: [MDPoolImportElement 
							className: self class name 
							poolName: #MDBogusPoolA]! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 20:22'!
testEditorSetForSliceAdaptor
	| adaptor |
	proxy instVarNamed: 'slices' put: self.
	adaptor _ (MDSliceElement forSlice: (MDExplicitSlice named: 'slice')) adaptedFor: proxy.
	self assert: (adaptor instVarNamed: 'system') == self
! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 12/24/2006 23:12'!
testProxyClearsEditorIfTransactionExitsEarly
	
	self endTransactionEarly.
	self assert: (proxy instVarNamed: 'editor') == Smalltalk! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 12/22/2006 22:37'!
testProxyCreatesSystemEditor
	| editor |
	proxy transaction:
		[editor _ proxy instVarNamed: 'editor'.
		self assert: (editor class == MDPlatform current systemEditor class)].! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 21:04'!
testProxyHasDefaultEnvironment
	
	self assert: (proxy instVarNamed: 'editor') == Smalltalk! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 12/24/2006 23:12'!
testProxyRemovesSystemEditor
	proxy transaction: ["do nothing"].
	self assert: (proxy instVarNamed: 'editor') == Smalltalk! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:42'!
testProxySendsCommitToEditor
	
	proxy transaction: [proxy instVarNamed: 'editor' put: self].
	self assert: commitWasCalled! !

MDAdaptionTest subclass: #MDSqueakAdaptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakAdaptionTest methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:33'!
proxyClass
	^ MDSqueakImageProxy! !

MDSliceTest subclass: #MDPackageSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDPackageSliceTest commentStamp: 'cwp 3/3/2005 02:10' prior: 0!
This comment needs to be here, or #testComment won't pass.!

!MDPackageSliceTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/3/2005 02:14'!
bogusMethodA
	"This method needs to be here for #testClassMethods to pass"! !

!MDPackageSliceTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/3/2005 02:14'!
bogusMethodB
	"This method needs to be here for #testClassMethods to pass"! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 8/29/2005 00:33'!
classes
	^ Array with: MDBogusA with: MDSliceTest! !

!MDPackageSliceTest methodsFor: 'constructing' stamp: 'cwp 3/3/2006 14:23'!
createSlice
	^MDPackageInfoSlice forPackage: self! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 8/29/2005 01:13'!
includesClassNamed: aSymbol
	^ self classes anySatisfy: [:ea | ea name = aSymbol]! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 8/29/2005 01:30'!
includesMethodReference: aMethodReference 
	^ self methods includes: aMethodReference! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 8/29/2005 00:43'!
methods
	^ Array
		with: (MethodReference class: MDSliceTest selector: #classes)
		with: (MethodReference class: MDSliceTest selector: #methods)
		with: (MethodReference class: MDSliceTest class selector: #bogusMethodA)
		with: (MethodReference class: MDSliceTest class selector: #bogusMethodB)
! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 3/16/2005 01:09'!
packageName
	^ 'TestPackage'! !

!Collection methodsFor: '*mc2-squeak' stamp: 'cwp 8/26/2005 21:58'!
disjoin: aCollection
	^ (self union: aCollection) difference: (self intersection: aCollection)! !

!SystemDictionary methodsFor: '*mc2-squeak' stamp: 'cwp 12/22/2006 22:35'!
commit
	! !

MDSlice subclass: #MDPackageInfoSlice
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Slices'!

!MDPackageInfoSlice class methodsFor: 'instance creation' stamp: 'abc 1/1/2007 01:03'!
forDefinition: properties
	^ self named: properties name! !

!MDPackageInfoSlice class methodsFor: 'instance creation' stamp: 'cwp 3/3/2005 00:49'!
forPackage: aPackage
	^ self basicNew setPackage: aPackage! !

!MDPackageInfoSlice class methodsFor: 'instance creation' stamp: 'cwp 8/28/2005 18:02'!
named: aString
	^ self forPackage: (PackageInfo named: aString)! !

!MDPackageInfoSlice class methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:34'!
type
	^ #Package! !

!MDPackageInfoSlice methodsFor: 'private' stamp: 'cwp 3/3/2006 14:27'!
class: aClass do: aBlock
	aBlock value: (MDClassElement className: aClass name).
	aClass hasComment ifTrue:
		[aBlock value: (MDClassCommentElement className: aClass name)].
	self 
		names: aClass instVarNames 
		collect: [:name | MDInstVarElement className: aClass name name: name]
		into: aBlock.
	self 
		names: aClass classVarNames
		collect: [:name | MDClassVarElement className: aClass name name: name]
		into: aBlock.
	self 
		names: aClass class instVarNames
		collect: [:name | MDClassInstVarElement className: aClass name name: name]
		into: aBlock.
	self
		names: aClass poolDictionaryNames
		collect: [:name | MDPoolImportElement className: aClass name poolName: name]
		into: aBlock! !

!MDPackageInfoSlice methodsFor: 'private' stamp: 'cwp 3/3/2006 11:15'!
classForElement: anElement
	^ (Smalltalk classNamed: anElement theClassName)! !

!MDPackageInfoSlice methodsFor: 'enumerating' stamp: 'cwp 1/18/2007 23:59'!
elementsDo: aBlock
	package classes do: [:class | self class: class do: aBlock].
	package methods do: [:ea | aBlock value: ea asElement].! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:06'!
includes: anElement
	^ anElement isIncludedInSlice: self! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:10'!
includesClass: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:09'!
includesClassComment: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 11/7/2007 00:33'!
includesClassInstVar: anElement
	^ (package includesClassNamed: anElement theClassName) and: 
		[(self classForElement: anElement) class instVarNames includes: anElement name]! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 11/7/2007 00:36'!
includesClassVar: anElement
	^ (package includesClassNamed: anElement theClassName)
		and: [(self classForElement: anElement) classVarNames includes: anElement name]! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 11/7/2007 00:35'!
includesInstVar: anElement
	^ (package includesClassNamed: anElement theClassName)
		and: [(self classForElement: anElement) instVarNames includes: anElement name]! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:24'!
includesMethod: anElement
	| ref |
	ref _ MethodReference new.
	ref 
		setClassSymbol: anElement theClassName
		classIsMeta: anElement classIsMeta
		methodSymbol: anElement selector
		stringVersion: ''.
	^ package includesMethodReference: ref! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 11/7/2007 01:07'!
includesPoolImport: anElement
	| pool |
	^ (package includesClassNamed: anElement theClassName) and: 
		[pool _ Smalltalk at: anElement name ifAbsent: [0].
		(self classForElement: anElement) sharedPools anySatisfy: 
				[:ea | ea == pool]]! !

!MDPackageInfoSlice methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:26'!
name
	^ package packageName! !

!MDPackageInfoSlice methodsFor: 'private' stamp: 'cwp 3/3/2005 01:48'!
names: aCollection collect: mapBlock into: doBlock
	| elements |
	elements := aCollection collect: mapBlock.
	elements do: doBlock. 
		! !

!MDPackageInfoSlice methodsFor: 'initialize-release' stamp: 'cwp 1/19/2007 22:59'!
setPackage: aPackage
	package _ aPackage.
	self initId.! !

SharedPool subclass: #MDBogusPoolA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Fakes'!

Object subclass: #MDBogusA
	instanceVariableNames: 'one'
	classVariableNames: 'Alpha'
	poolDictionaries: 'MDBogusPoolA TextConstants ScheduledControllers'
	category: 'MC2-Squeak-Fakes'!

MDBogusA class
	instanceVariableNames: 'aleph'!

SharedPool subclass: #MDBogusPoolB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Fakes'!
